searchNodes=[{"doc":"","ref":"Sanity.Cache.html","title":"Sanity.Cache","type":"module"},{"doc":"Defines a Sanity query. Options :config_key - The default value is :default . :projection - Required. :list_query - Required. :lookup - Required.","ref":"Sanity.Cache.html#defq/2","title":"Sanity.Cache.defq/2","type":"macro"},{"doc":"Fetches a single document by making a request to the Sanity CMS API. The cache is not used. Options :config_key - The default value is :default . :projection - Required. :fetch_query - Required.","ref":"Sanity.Cache.html#fetch/2","title":"Sanity.Cache.fetch/2","type":"function"},{"doc":"Fetches list of key/value pairs. Options :config_key - The default value is :default . :projection - Required. :list_query - Required. :keys - Required.","ref":"Sanity.Cache.html#fetch_pairs/1","title":"Sanity.Cache.fetch_pairs/1","type":"function"},{"doc":"Gets a single document using cache. If the cache table doesn't exist then fetch/2 will be called. Returns {:ok, value} or {:error, :not_found} .","ref":"Sanity.Cache.html#get/3","title":"Sanity.Cache.get/3","type":"function"},{"doc":"Like get/3 except raises if not found.","ref":"Sanity.Cache.html#get!/3","title":"Sanity.Cache.get!/3","type":"function"},{"doc":"Updates a cache table. Options :fetch_pairs_mfa - Required. :table - Required. :update_remote_nodes - The default value is false .","ref":"Sanity.Cache.html#update/1","title":"Sanity.Cache.update/1","type":"function"},{"doc":"For caching results in an ETS table. A single instance of this GenServer is started automatically.","ref":"Sanity.Cache.CacheServer.html","title":"Sanity.Cache.CacheServer","type":"module"},{"doc":"Like put_table/3 , except uses GenServer.cast/2 .","ref":"Sanity.Cache.CacheServer.html#cast_put_table/3","title":"Sanity.Cache.CacheServer.cast_put_table/3","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Sanity.Cache.CacheServer.html#child_spec/1","title":"Sanity.Cache.CacheServer.child_spec/1","type":"function"},{"doc":"Deletes a table if it exists. Returns :ok or {:error, :no_table} . Examples iex&gt; delete_table ( :nonexistent_doctest_table ) { :error , :no_table }","ref":"Sanity.Cache.CacheServer.html#delete_table/2","title":"Sanity.Cache.CacheServer.delete_table/2","type":"function"},{"doc":"Fetches a value from the cache. Returns one of the following {:ok, value} if the item is found {:error, :no_table} if the table doesn't exist {:error, :not_found} if the table exists but doesn't contain the specified key","ref":"Sanity.Cache.CacheServer.html#fetch/3","title":"Sanity.Cache.CacheServer.fetch/3","type":"function"},{"doc":"Creates or replaces a table with the given names. pairs must be a map or a list of key value pairs like [{:my_key, :my_value}] . Examples iex&gt; put_table ( :doctest_table , [ { &quot;key&quot; , &quot;value&quot; } ] ) :ok","ref":"Sanity.Cache.CacheServer.html#put_table/3","title":"Sanity.Cache.CacheServer.put_table/3","type":"function"},{"doc":"See GenServer.start_link/3 .","ref":"Sanity.Cache.CacheServer.html#start_link/1","title":"Sanity.Cache.CacheServer.start_link/1","type":"function"},{"doc":"","ref":"Sanity.Cache.NotFoundError.html","title":"Sanity.Cache.NotFoundError","type":"exception"},{"doc":"Opinionated library for caching Sanity CMS content in an ETS table for submillisecond response times.","ref":"readme.html","title":"Sanity.Cache","type":"extras"},{"doc":"The package can be installed by adding sanity_cache to your list of dependencies in mix.exs : def deps do [ { :sanity_cache , &quot;~&gt; 0.4.0&quot; } ] end You may also want to add sanity_cache to your .formatter.exs file so that defq calls are formatted nicely. # .formatter.exs [ # ... import_deps : [ :sanity_cache ] ]","ref":"readme.html#installation","title":"Sanity.Cache - Installation","type":"extras"},{"doc":"# config.exs or runtime.exs config :sanity_cache , :default , dataset : &quot;production&quot; , project_id : &quot;project-id-from-sanity&quot; , token : &quot;api-token-with-read-permission&quot; If you need to connect to mulitiple Sanity CMS datasets then you can use a key other than :default and set the :config_key opt when calling defq .","ref":"readme.html#configuration","title":"Sanity.Cache - Configuration","type":"extras"},{"doc":"Basic usage Create a module in your application like: defmodule MyApp.CMS do @page_projection &quot;{ ... }&quot; use Sanity.Cache defq :page , list_query : ~S&#39;*[_type == &quot;page&quot; &amp;&amp; !(_id in path(&quot;drafts.**&quot;))]&#39; , projection : @page_projection , lookup : [ id : [ fetch_query : ~S&#39;*[_type == &quot;page&quot; &amp;&amp; _id == $key]&#39; , keys : [ :_id ] ] , path : [ fetch_query : ~S&#39;*[_type == &quot;page&quot; &amp;&amp; path.current == $key &amp;&amp; !(_id in path(&quot;drafts.**&quot;))]&#39; , keys : [ :path , :current ] ] ] end This generates the following functions: MyApp.CMS.child_spec/1 MyApp.CMS.get_page_by_id/1 MyApp.CMS.get_page_by_id!/1 MyApp.CMS.get_page_by_path/1 MyApp.CMS.get_page_by_path!/1 MyApp.CMS.update_all/1 At this point no caching is taking place. Each call to a function like MyApp.CMS.get_page_by_path/1 will make a request to the Sanity CMS API. Polling for new content Configure MyApp.CMS to start when your application starts. This will fetch content when your application starts and poll for new content every few minutes. Now, functions like MyApp.CMS.get_page_by_path/1 will get data from the cache instead of making calls to the Sanity CMS API. A useful trick is to not start this process during development so you will get fresh CMS data every time you refresh the page. defmodule MyApp.Application do use Application @impl true def start ( _type , _args ) do children = [ # ... MyApp.CMS ] # ... end Instantly updating cached content using Sanity webhooks If you are fine waiting a few minutes for content changes to be reflected in your app then you are done. But if you want changes to be reflected instantly then you'll need to listen for Sanity webhooks. Here is an example using a Phoenix controller: defmodule MyAppWeb.SanityWebhookController do use MyAppWeb , :controller alias MyApp.CMS def update ( conn , %{ } ) do CMS . update_all ( update_remote_nodes : true ) text ( conn , &quot;ok&quot; ) end end Add this controller to your router.ex file and configure Sanity webhooks accordingly . The :update_remote_nodes option will result in the updated results being casted to all Erlang nodes (see Node.list/0 ) in the cluster, ensuring that the cache is up to date on all nodes. If you run more than one node (server) then you will need to ensure that Erlang clustering is enabled.","ref":"readme.html#usage","title":"Sanity.Cache - Usage","type":"extras"}]